# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section   free
%define svn_tag   1_0

Name:           nanocontainer-nanowar
Version:        1.0
Release:        3%{?dist}
Epoch:          0
Summary:        NanoContainer component

Group:          Development/Libraries/Java
License:        BSD -style
URL:            http://nanocontainer.codehaus.org/
Source0:        nanocontainer-nanowar-1_0.tar.gz
# svn export https://svn.codehaus.org/picocontainer/java/nanocontainer-nanowar/tags/nanocontainer-nanowar-1_0/nanocontainer-nanowar-1_0/

Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        %{name}-%{version}-jpp-depmap.xml
Source5:        http://repo2.maven.org/maven2/nanocontainer/nanocontainer-nanowar/1.0/nanocontainer-nanowar-1.0.pom
Patch0:         %{name}-%{version}-project_xml.patch
Patch1:         %{name}-%{version}-bootstrap-project_xml.patch

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  maven >= 0:1.1
BuildRequires:  maven-plugins-base
BuildRequires:  maven-plugin-multiproject
BuildRequires:  maven-plugin-license
BuildRequires:  maven-plugin-scm
BuildRequires:  maven-plugin-test
BuildRequires:  maven-plugin-xdoc
BuildRequires:  saxon
BuildRequires:  saxon-scripts
BuildRequires:  jmock
BuildRequires:  junit >= 0:3.8.1

BuildRequires:  axis
BuildRequires:  cglib
BuildRequires:  groovy
BuildRequires:  httpunit
BuildRequires:  jakarta-commons-beanutils
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-digester
BuildRequires:  jakarta-commons-logging >= 0:1.1
BuildRequires:  jetty5
BuildRequires:  log4j
BuildRequires:  nanocontainer >= 0:1.1.2
BuildRequires:  ognl
BuildRequires:  oscore
BuildRequires:  picocontainer
BuildRequires:  proxytoys
BuildRequires:  rife-continuations
BuildRequires:  servletapi4
BuildRequires:  struts
BuildRequires:  tomcat5-jasper
BuildRequires:  velocity
BuildRequires:  velocity-tools
BuildRequires:  webwork >= 0:2.1.7
BuildRequires:  xmlunit
BuildRequires:  xstream
BuildRequires:  xwork

Requires:  java-devel >= 0:1.5.0
Requires:  axis
Requires:  cglib
Requires:  groovy
Requires:  httpunit
Requires:  jakarta-commons-beanutils
Requires:  jakarta-commons-collections
Requires:  jakarta-commons-digester
Requires:  jakarta-commons-logging >= 0:1.1
Requires:  log4j
Requires:  nanocontainer >= 0:1.1.2
Requires:  ognl
Requires:  oscore
Requires:  picocontainer
Requires:  proxytoys
Requires:  rife-continuations
Requires:  struts
Requires:  velocity
Requires:  velocity-tools
# Optional Requires:  webwork >= 0:2.1.7
Requires:  xmlunit
Requires:  xstream
Requires:  xwork

Requires(post):    jpackage-utils >= 0:1.7.3
Requires(postun):  jpackage-utils >= 0:1.7.3

%description
NanoWar is a NanoContainer component that brings the power 
of PicoContainer's Dependency Injection to the Java 
Servlet/Web application world.
NanoWar allows to embed NanoContainer in a Java Servlet 
container.
NanoWar is non-intrusively activated in a Web application 
via a Servlet container event listener, configured in the 
web.xml.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.


%prep
%setup -q -n %{name}-%{svn_tag}

%patch0 -b .sav0
%patch1 -b .sav1

cp nanowar/src/test/org/nanocontainer/nanowar/webwork/TestAction.java .
find nanowar/src -depth -type d -name "webwork" -exec rm -rf {} \;
mkdir -p nanowar/src/test/org/nanocontainer/nanowar/webwork
mv TestAction.java nanowar/src/test/org/nanocontainer/nanowar/webwork

find . -depth -type d -name "webwork1" -exec rm -rf {} \;


%build
export DEPCAT=$(pwd)/%{name}-%{version}-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > %{name}-%{version}-depmap.new.xml
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

export MAVEN_HOME_LOCAL=$(pwd)/.maven

maven \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        -Dgoal=jar:install,javadoc:generate,xdoc:transform \
        multiproject:goal

%install
rm -rf $RPM_BUILD_ROOT
#jars
install -dm 755 $RPM_BUILD_ROOT%{_javadir}
install -pm 644 nanowar/target/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
# create unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)
%add_to_maven_depmap nanocontainer %{name} %{version} JPP %{name}

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE5} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

#javadocs
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr nanowar/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

#manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/*.jar
%{_mavendepmapfragdir}/*
%{_datadir}/maven2/poms/*
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}*-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Wed May 06 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.0-3.jpp5
- Make Requires webwork optional

* Tue Apr 28 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.0-2.jpp5
- First JPP-5 release

* Tue Oct 17 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.0-1jpp
- First JPP-1.7 release
- Add post/postun Requires for javadoc
- Add gcj_support option
- webwork1 not supported
